<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>One Network UI Test Problem</title>
    <style>
        body {
            padding: 10px;
            margin-left: 500px;
            background-color: black;
        }
        #mobileid {
            color: aqua;
            margin-left: 200px;
        }
        #list {
            border: 1px solid red !important;
            background-color: white !important;
            width: 350px;
        }
        li{
            border: 1px solid black;
            width: 300px;
        }
        .main_content {
            width: 100%;
            text-align: center;
        }
        strong{
            color: white
        }
    </style>
</head>

<body>
    &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <strong>Search: </strong> <input type="text" id="myInput" onkeyup="myFunction()" placeholder="please search..">
    <br>
    <br>
    &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <strong>Sort: </strong> <select id="comboA" onchange="getComboA(this)">
        <option value="">--Select--</option>
        <option value="Name">Name</option>
        <option value="Mobile">Mobile</option>
        <option value="Position">Position</option>
        <option value="HireDate">Hire Date</option>
    </select>

    <ul id="list"></ul>

    <script>
        var employeesById = {
            "8110923": { "Name": "John Glanton", "Position": "Chief Executive", "Hire Date": "2008-01-15" },
            "7734981": { "Name": "Samuel Chamberlain", "Position": "Sales", "Hire Date": "2012-05-01" },
            "3400981": { "Name": "Louis Toadvine", "Position": "Customer Support", "Hire Date": "2011-08-24" },
            "5517823": { "Name": "Ben Tobin", "Position": "Developer", "Hire Date": "2013-03-19" },
            "4587234": { "Name": "David Brown", "Position": "Director of HR", "Hire Date": "2012-01-10" }
        }

        var ul = document.getElementById("list");
        ul.setAttribute('style', 'list-style-type:none');
        var sortable = [];
        for (const property in employeesById) {
            sortable.push({
                "Mobile": property,
                "Name": employeesById[property].Name,
                "Position": employeesById[property].Position,
                "HireDate": employeesById[property]['Hire Date']
            })
            let li = document.createElement("li");
            li.innerHTML = `<div class="container">
              <div class="child">
                <span id="nameid">${employeesById[property].Name}</span><br>
              
              <span class="details" id="positionid">${employeesById[property].Position}</span><br>
              <span class="details" id="hiredateid">Employee Since ${employeesById[property]['Hire Date']}</span>
              </div>
              <div class="details child" id="mobileid">${property}</div>
            </div>

              <br>`;
            li.setAttribute('style', 'margin: 10px; text-align:left');

            ul.appendChild(li);
        }

        function myFunction() {
            // Declare variables
            var input, filter, ul, li, a, i, txtValue;
            input = document.getElementById('myInput');
            filter = input.value.toUpperCase();
            ul = document.getElementById("list");
            li = ul.getElementsByTagName('li');

            // Loop through all list items, and hide those who don't match the search query
            for (i = 0; i < li.length; i++) {
                txtValue = li[i].getElementsByTagName('span')[0].innerText;
                if (txtValue.toUpperCase().indexOf(filter) > -1) {
                    li[i].style.display = "";
                } else {
                    li[i].style.display = "none";
                }
            }
        }

        function getComboA(selectObject) {
            var value = selectObject.value;
            switch (value) {
                case 'Name':
                    ul.innerHTML = '';
                    let _namesorted = sortable.sort((a, b) => {
                        if (a.Name < b.Name) return -1;
                        if (a.Name > b.Name) return 1;
                        return 0;
                    });
                    _namesorted.forEach(item => {
                        let li = document.createElement("li");
                        li.innerHTML = `<span id="nameid">${item.Name}</span><br>
                                        <span id="mobileid">${item.Mobile}</span><br>
                                        <span id="positionid">${item.Position}</span><br>
                                        <span id="hiredateid">Employee Since ${item.HireDate}</span>`;
                        li.setAttribute('style', 'margin: 10px;');
                        ul.appendChild(li);
                    })
                    break;

                case 'Mobile':
                ul.innerHTML = '';
                    let _mobilesorted = sortable.sort((a, b) => {
                        if (a.Mobile < b.Mobile) return -1;
                        if (a.Mobile > b.Mobile) return 1;
                        return 0;
                    });
                    _mobilesorted.forEach(item => {
                        let li = document.createElement("li");
                        li.innerHTML = `<span id="nameid">${item.Name}</span><br>
                                        <span id="mobileid">${item.Mobile}</span><br>
                                        <span id="positionid">${item.Position}</span><br>
                                        <span id="hiredateid">Employee Since ${item.HireDate}</span>`;
                        li.setAttribute('style', 'margin: 10px;');
                        ul.appendChild(li);
                    })
                    break;

                case 'Position':
                ul.innerHTML = '';
                    let _positionsorted = sortable.sort((a, b) => {
                        if (a.Position < b.Position) return -1;
                        if (a.Position > b.Position) return 1;
                        return 0;
                    });
                    _positionsorted.forEach(item => {
                        let li = document.createElement("li");
                        li.innerHTML = `<span id="nameid">${item.Name}</span><br>
                                        <span id="mobileid">${item.Mobile}</span><br>
                                        <span id="positionid">${item.Position}</span><br>
                                        <span id="hiredateid">Employee Since ${item.HireDate}</span>`;
                        li.setAttribute('style', 'margin: 10px;');
                        ul.appendChild(li);
                    })
                    break;

                case 'HireDate':
                ul.innerHTML = '';
                    let _hireDatesorted = sortable.sort((a, b) => {
                        if (a.HireDate < b.HireDate) return -1;
                        if (a.HireDate > b.HireDate) return 1;
                        return 0;
                    });
                    _hireDatesorted.forEach(item => {
                        let li = document.createElement("li");
                        li.innerHTML = `<span id="nameid">${item.Name}</span><br>
                                        <span id="mobileid">${item.Mobile}</span><br>
                                        <span id="positionid">${item.Position}</span><br>
                                        <span id="hiredateid">Employee Since ${item.HireDate}</span>`;
                        li.setAttribute('style', 'margin: 10px;');
                        ul.appendChild(li);
                    })
                    break;

            }
        }
    </script>
</body>

</html>
